#include "Vram.h"
#include "VVram.h"
#include "CopyMemory.h"
#include "Chars.h"

extern byte[] Backup;

static const byte[] ColorSource = {
    Char_Logo, 25, 0x95,
    Char_Ladder_Left, 2, 0x96,
    Char_Monster, 32, 0x93,
    Char_Item, 4, 0x96,
    0xff
};

byte[256] CharColors;

static void SetColor(ptr<byte> pColor, byte color, byte count)
{
    do {
        *pColor = color;
        ++pColor;
        --count;
    } while (count != 0);
}

void InitVram()
{
    ptr<byte> pColor, pSource;

    pColor = CharColors;
    repeat (0) {
        *pColor = 0x97;
        ++pColor;
    }

    pSource = ColorSource;
    while (pSource[0] != 0xff) {
        byte count, color;
        pColor = CharColors + pSource[0];
        count = pSource[1];
        color = pSource[2];
        pSource += 3;
        do {
            *pColor = color;
            ++pColor;
            --count;
        } while (count > 0);
    }
}


void ClearScreen()
{
    *((ptr<byte>)0xffd8) = 0x97;
    FillMemory(Vram, 0x2000, 0);
    FillMemory(Backup, VVramWidth * VVramHeight, 0);
    ClearRowFlags();
}


ptr<byte> PrintC(ptr<byte> pVram, byte c)
{
    return Put(pVram, c - ' ');
}


void Put2C(ptr<byte> pVram, byte c)
{
    repeat (2) {
        repeat (2) {
            pVram = Put(pVram, c);
            ++c;
        }
        pVram += VramRowSize - 2 * VramStep;
    }
}
