include 'Vram.inc'
include 'VVram.inc'

RowStep equ $0400
VramTop equ Vram

ext VVramFront_, RowFlags_
ext ClearRowFlags_
ext Chars_
ext CharColors_

zseg

Direct: public Direct
@Temp@Byte: defb 0
@Temp@ByteCount: defb 0
@Temp@Word: defw 0
@Temp@Word2: defw 0 
@Temp@WordCount: defw 0 

Dp.Word0: defw 0
Dp.Word1: defw 0
Dp.Counter0: defb 0
Dp.Counter1: defb 0
Dp.X: defb 0
Dp.Y: defb 0
Dp.C: defb 0

    dseg
Backup_: public Backup_
    defs VVramWidth*VVramHeight

; ptr<byte> Put(ptr<byte> pVram, byte c);
cseg
Put_: public Put_
    pshs a,b,x,y
        ldy #CharColors_
        clra
        lda d,y
        sta $FFD8   ;C-REG-SEL

        lda #8
        mul
        ldy #Chars_
        leay d,y
        ldb #8
        do
            lda ,y+
            sta ,x
            leax RowStep,x
            decb
        while ne | wend
    puls a,b,x,y
    tfr	x,d
    addd #1
rts


; ; void VVramToVram();
; VVramToVram_: public VVramToVram_
;     pshs a,b,x,y
;         ldx #VramTop
;         stx <Dp.Word0
;         ldx #VVram_
;         ldy #Backup_
;         lda #VVramHeight
;         sta <Dp.Counter0
;         do
;             lda #VVramWidth
;             sta <Dp.Counter1
;             do 
;                 ldb ,x+
;                 cmpb ,y
;                 if ne
;                     stb ,y
;                     pshs x
;                         ldx <Dp.Word0
;                         bsr Put_
;                     puls x
;                 endif
;                 leay 1,y
;                 pshs x
;                     ldx <Dp.Word0
;                     leax 1,x
;                     stx <Dp.Word0
;                 puls x
;                 dec <Dp.Counter1
;             while ne | wend
;             pshs x
;                 ldx <Dp.Word0
;                 leax VramWidth-VVramWidth,x
;                 stx <Dp.Word0
;             puls x
;             dec <Dp.Counter0
;         while ne | wend
;     puls a,b,x,y
; rts


VVramToVramRow:
    lda #VVramWidth
    sta <Dp.Counter1
    do 
        ldb ,x+
        cmpb ,y
        if ne
            stb ,y
            pshs x
                ldx <Dp.Word0
                bsr Put_
            puls x
        endif
        leay 1,y
        pshs x
            ldx <Dp.Word0
            leax 1,x
            stx <Dp.Word0
        puls x
        dec <Dp.Counter1
    while ne | wend
    pshs x
        ldx <Dp.Word0
        leax VramWidth-VVramWidth,x
        stx <Dp.Word0
    puls x
rts


; void VVramToVramAll();
VVramToVramAll_: public VVramToVramAll_
    pshs a,b,x,y
        ldx #Vram
        stx <Dp.Word0
        ldx #VVramFront_
        ldy #Backup_
        lda #VVramHeight
        sta <Dp.Counter0
        do
            bsr VVramToVramRow
            dec <Dp.Counter0
        while ne | wend
        jsr ClearRowFlags_
    puls a,b,x,y
rts


; void VVramToVramChanged();
VVramToVramChanged_: public VVramToVramChanged_
    pshs a,b,x,y
        ldx #Vram
        stx <Dp.Word0
        ldx #RowFlags_
        lda ,x+
        sta <Dp.Y
        stx <Dp.Word1
        lda #1
        sta <Dp.X

        ldx #VVramFront_
        ldy #Backup_
        lda #VVramHeight
        sta <Dp.Counter0
        do
            lda <Dp.Y
            anda <Dp.X
            if ne
                bsr VVramToVramRow
            else
                leax VVramWidth,x
                leay VVramWidth,y
                pshs x
                    ldx <Dp.Word0
                    leax VramWidth,x
                    stx <Dp.Word0
                puls x
            endif
            lsl <Dp.X
            if eq
                pshs x
                    ldx <Dp.Word1
                    lda ,x+
                    sta <Dp.Y
                    stx <Dp.Word1
                    lda #1
                    sta <Dp.X
                puls x
            endif
            dec <Dp.Counter0
        while ne | wend
        jsr ClearRowFlags_
    puls a,b,x,y
rts